#include "stdafx.h"

#include <string>
#include "Util.h"

using namespace System;
using namespace System::Text;
using namespace System::Collections::Generic;
using namespace Microsoft::VisualStudio::TestTools::UnitTesting;

namespace TestBkBsfilWrapper
{
	[TestClass]
	public ref class UnitTestUtil
	{
	private:
		TestContext^ testContextInstance;

	public: 
		/// <summary>
		///݂̃eXg̎sɂĂ̏񂨂ы@\
		///񋟂eXg ReLXg擾܂͐ݒ肵܂B
		///</summary>
		property Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ TestContext
		{
			Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ get()
			{
				return testContextInstance;
			}
			System::Void set(Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ value)
			{
				testContextInstance = value;
			}
		};

		#pragma region Additional test attributes
		//
		//eXg쐬ۂɂ́A̒ǉgpł܂:
		//
		//NXōŏ̃eXgsOɁAClassInitialize gpăR[hsĂ
		//[ClassInitialize()]
		//static void MyClassInitialize(TestContext^ testContext) {};
		//
		//NX̃eXgׂĎsAClassCleanup gpăR[hsĂ
		//[ClassCleanup()]
		//static void MyClassCleanup() {};
		//
		//eeXgsOɁATestInitialize gpăR[hsĂ
		//[TestInitialize()]
		//void MyTestInitialize() {};
		//
		//eeXgsɁATestCleanup gpăR[hsĂ
		//[TestCleanup()]
		//void MyTestCleanup() {};
		//
		#pragma endregion 

		//
		// GetHeaderFieldPosition
		//

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(12, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal1_1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge:Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(5, indexBodyStart);
			Assert::AreEqual(11, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal1_2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge:\tName\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(12, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal1_3()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge:\t Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(7, indexBodyStart);
			Assert::AreEqual(13, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n Name2\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(20, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal2_1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\tName2\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(20, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal2_2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\tName2\r\n Name3\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(28, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal3()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Test: Value\r\nHoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(13, indexFieldNameStart);
			Assert::AreEqual(17, indexFieldNameEnd);
			Assert::AreEqual(19, indexBodyStart);
			Assert::AreEqual(25, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal3_1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Test: Value\r\nHoge:Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(13, indexFieldNameStart);
			Assert::AreEqual(17, indexFieldNameEnd);
			Assert::AreEqual(18, indexBodyStart);
			Assert::AreEqual(24, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal4()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("\r\nHoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(2, indexFieldNameStart);
			Assert::AreEqual(6, indexFieldNameEnd);
			Assert::AreEqual(8, indexBodyStart);
			Assert::AreEqual(14, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessNormal5()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Test: Value\r\nHoge: Name\r\nTest2: Value2\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(13, indexFieldNameStart);
			Assert::AreEqual(17, indexFieldNameEnd);
			Assert::AreEqual(19, indexBodyStart);
			Assert::AreEqual(25, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionSuccessIgnoreCase1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "HOGE", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(12, indexBodyEnd);
		}
		
		[TestMethod]
		void TestGetHeaderFieldPositionSuccessIgnoreCase2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("HOGE: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(true, result);
			Assert::AreEqual(0, indexFieldNameStart);
			Assert::AreEqual(4, indexFieldNameEnd);
			Assert::AreEqual(6, indexBodyStart);
			Assert::AreEqual(12, indexBodyEnd);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNormal1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNormal1_1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hage", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNormal2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge : Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNormal3()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNormal4()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("TsHoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNull1()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition(0, "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNull2()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", 0, &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);
		}

		[TestMethod]
		void TestGetHeaderFieldPositionFailureNull3()
		{
			int indexFieldNameStart = 0;
			int indexFieldNameEnd = 0;
			int indexBodyStart = 0;
			int indexBodyEnd = 0;

			bool result;

			result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hoge", 0, &indexFieldNameEnd, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);

			result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, 0, &indexBodyStart, &indexBodyEnd);
			Assert::AreEqual(false, result);

			result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, 0, &indexBodyEnd);
			Assert::AreEqual(false, result);

			result = Util::GetHeaderFieldPosition("Hoge: Name\r\n\r\n", "Hoge", &indexFieldNameStart, &indexFieldNameEnd, &indexBodyStart, 0);
			Assert::AreEqual(false, result);
		}

		//
		// GetHeaderFieldBody
		//

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal1()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge: Name\r\n\r\n", "Hoge");
			Assert::AreEqual(4, (int) result.length());
			Assert::AreEqual(gcnew String("Name"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal1_1()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge:Name\r\n\r\n", "Hoge");
			int length = result.length();
			Assert::AreEqual(4, (int) result.length());
			Assert::AreEqual(gcnew String("Name"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal1_2()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge:\tName\r\n\r\n", "Hoge");
			int length = result.length();
			Assert::AreEqual(4, (int) result.length());
			Assert::AreEqual(gcnew String("Name"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal2()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge: Name Value\r\n\r\n", "Hoge");
			int length = result.length();
			Assert::AreEqual(10, (int) result.length());
			Assert::AreEqual(gcnew String("Name Value"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal4()
		{
			std::string result = Util::GetHeaderFieldBody("Test: Value\r\nHoge: Name\r\n\r\n", "Hoge");
			Assert::AreEqual(4, (int) result.length());
			Assert::AreEqual(gcnew String("Name"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal4_1()
		{
			std::string result = Util::GetHeaderFieldBody("Test: Value\r\nHoge: Name Value\r\n\r\n", "Hoge");
			Assert::AreEqual(10, (int) result.length());
			Assert::AreEqual(gcnew String("Name Value"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal5()
		{
			std::string result = Util::GetHeaderFieldBody("Test: Value\r\nHoge: Name\r\nVal: EEE\r\n\r\n", "Hoge");
			Assert::AreEqual(4, (int) result.length());
			Assert::AreEqual(gcnew String("Name"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal6()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge: Name\r\n Value\r\n\r\n", "Hoge");
			Assert::AreEqual(12, (int) result.length());
			Assert::AreEqual(gcnew String("Name\r\n Value"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal6_1()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge: Name\r\n Value\r\n\tChange\r\n\r\n", "Hoge");
			Assert::AreEqual(21, (int) result.length());
			Assert::AreEqual(gcnew String("Name\r\n Value\r\n\tChange"), gcnew String(result.c_str()));
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessNormal7()
		{
			bool bFind = false;
			std::string result = Util::GetHeaderFieldBody("Hoge: \r\n\r\n", "Hoge", &bFind);
			Assert::AreEqual(true, bFind);
			Assert::AreEqual(0, (int) result.length());
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessFailure1()
		{
			std::string result = Util::GetHeaderFieldBody("Hoge: Name\r\n Value\r\n\tChange\r\n", "Hoge");
			Assert::AreEqual(0, (int) result.length());
		}

		[TestMethod]
		void TestGetHeaderFieldBodySuccessFailure2()
		{
			bool bFind = false;
			std::string result = Util::GetHeaderFieldBody("Hoge1: \r\n\r\n", "Hoge", &bFind);
			Assert::AreEqual(false, bFind);
			Assert::AreEqual(0, (int) result.length());
		}

		//
		// AddSpamHeader
		//

		[TestMethod]
		void TestAddSpamHeader1()
		{
			std::string mail = "Test Header: Test\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(true, bAdd);

			std::string mailNewExpected = "X-SpamHeader: spam\r\nTest Header: Test\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestAddSpamHeader1_1()
		{
			std::string mail = "Test0 Header: Test 0\r\n cont 0\r\nTest Header: Test\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(true, bAdd);

			std::string mailNewExpected = "X-SpamHeader: spam\r\nTest0 Header: Test 0\r\n cont 0\r\nTest Header: Test\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestAddSpamHeader2()
		{
			std::string mail = "X-SpamHeader: spam\r\nTest Header: Test\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(false, bAdd);
			Assert::AreEqual(0U, mailNew.size());
		}

		[TestMethod]
		void TestAddSpamHeader3()
		{
			std::string mail = "Test Header: Test\r\nX-SpamHeader: spam\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(false, bAdd);
			Assert::AreEqual(0U, mailNew.size());
		}

		[TestMethod]
		void TestAddSpamHeader4()
		{
			std::string mail = "Test Header: Test\r\nX-SpamHeader: spam\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(false, bAdd);
			Assert::AreEqual(0U, mailNew.size());
		}

		[TestMethod]
		void TestAddSpamHeader5()
		{
			std::string mail = "\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(true, bAdd);

			std::string mailNewExpected = "X-SpamHeader: spam\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestAddSpamHeader6()
		{
			std::string mail = "\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";
			std::string spamHeader = "X-SpamHeader: spam\r\n";

			std::vector<char> mailNew;
			bool bAdd = Util::AddSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &spamHeader, &mailNew);
			Assert::AreEqual(true, bAdd);

			std::string mailNewExpected = "X-SpamHeader: spam\r\n\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		//
		// RemoveSpamHeader
		//

		[TestMethod]
		void TestRemoveSpamHeader1()
		{
			std::string mail = "X-SpamHeader: spam\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(true, bRemove);

			std::string mailNewExpected = "Test2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestRemoveSpamHeader2()
		{
			std::string mail = "Test1 Header: Test 1\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(false, bRemove);
			Assert::AreEqual(0U, mailNew.size());
		}

		[TestMethod]
		void TestRemoveSpamHeader3()
		{
			std::string mail = "Test1 Header: Test 1\r\nX-SpamHeader: spam\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(true, bRemove);

			std::string mailNewExpected = "Test1 Header: Test 1\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestRemoveSpamHeader4()
		{
			std::string mail = "Test1 Header: Test 1\r\n cont test1\r\nX-SpamHeader: spam\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(true, bRemove);

			std::string mailNewExpected = "Test1 Header: Test 1\r\n cont test1\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestRemoveSpamHeader5()
		{
			std::string mail = "Test1 Header: Test 1\r\n cont test1\r\nTest2 Header: Test 2\r\nX-SpamHeader: spam\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(true, bRemove);

			std::string mailNewExpected = "Test1 Header: Test 1\r\n cont test1\r\nTest2 Header: Test 2\r\n\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestRemoveSpamHeader6()
		{
			std::string mail = "X-SpamHeader: spam\r\n\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(true, bRemove);

			std::string mailNewExpected = "\r\nMail Body\r\n.\r\n";
			int cmp = memcmp(mailNewExpected.c_str(), &mailNew[0], 	mailNewExpected.length() + 1);
			Assert::AreEqual(0, cmp);
		}

		[TestMethod]
		void TestRemoveSpamHeader7()
		{
			std::string mail = "\r\nMail Body\r\n.\r\n";
			std::string spamHeaderFieldName = "X-SpamHeader";

			std::vector<char> mailNew;
			bool bRemove = Util::RemoveSpamHeader(mail.c_str(), mail.length(), &spamHeaderFieldName, &mailNew);
			Assert::AreEqual(false, bRemove);
			Assert::AreEqual(0U, mailNew.size());
		}
	};
}
